blob: e26f02dbedee444d228db852f1afc5972831acf0 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070038 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
Peter Zijlstra6804c1a2020-03-18 13:33:54 +010058objtool_link()
59{
60 local objtoolopt;
61
62 if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
63 objtoolopt="check"
64 if [ -z "${CONFIG_FRAME_POINTER}" ]; then
65 objtoolopt="${objtoolopt} --no-fp"
66 fi
67 if [ -n "${CONFIG_GCOV_KERNEL}" ]; then
68 objtoolopt="${objtoolopt} --no-unreachable"
69 fi
70 if [ -n "${CONFIG_RETPOLINE}" ]; then
71 objtoolopt="${objtoolopt} --retpoline"
72 fi
73 if [ -n "${CONFIG_X86_SMAP}" ]; then
74 objtoolopt="${objtoolopt} --uaccess"
75 fi
76 info OBJTOOL ${1}
77 tools/objtool/objtool ${objtoolopt} ${1}
78 fi
79}
80
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020081# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070082# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -070083# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020084vmlinux_link()
85{
86 local lds="${objtree}/${KBUILD_LDS}"
Andrii Nakryiko618916a2019-09-05 10:59:38 -070087 local output=${1}
Stephen Rothwella5967db2016-08-24 22:29:19 +100088 local objects
Kees Cookaf73d782020-03-03 18:18:34 -080089 local strip_debug
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020090
Linus Torvaldsd7b08272019-09-20 08:36:47 -070091 info LD ${output}
92
Andrii Nakryiko618916a2019-09-05 10:59:38 -070093 # skip output file argument
94 shift
95
Kees Cookaf73d782020-03-03 18:18:34 -080096 # The kallsyms linking does not need debug symbols included.
97 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
98 strip_debug=-Wl,--strip-debug
99 fi
100
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200101 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000102 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900103 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000104 --no-whole-archive \
105 --start-group \
106 ${KBUILD_VMLINUX_LIBS} \
107 --end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700108 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000109
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700110 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800111 ${strip_debug#-Wl,} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700112 -o ${output} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000113 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200114 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000115 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +0900116 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000117 -Wl,--no-whole-archive \
118 -Wl,--start-group \
119 ${KBUILD_VMLINUX_LIBS} \
120 -Wl,--end-group \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700121 ${@}"
Stephen Rothwella5967db2016-08-24 22:29:19 +1000122
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700123 ${CC} ${CFLAGS_vmlinux} \
Kees Cookaf73d782020-03-03 18:18:34 -0800124 ${strip_debug} \
Andrii Nakryiko618916a2019-09-05 10:59:38 -0700125 -o ${output} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +1000126 -Wl,-T,${lds} \
127 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +1000128 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200129 rm -f linux
130 fi
131}
132
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700133# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700134# ${1} - vmlinux image
135# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700136gen_btf()
137{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700138 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700139
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700140 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000141 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700142 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700143 fi
144
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700145 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100146 if [ "${pahole_ver}" -lt "116" ]; then
147 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700148 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700149 fi
150
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700151 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800152
153 info "BTF" ${2}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700154 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700155
Fangrui Song90ceddc2020-03-18 15:27:46 -0700156 # Create ${2} which contains just .BTF section but no symbols. Add
157 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
158 # deletes all symbols including __start_BTF and __stop_BTF, which will
159 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
160 # objcopy warnings: "empty loadable segment detected at ..."
161 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
162 --strip-all ${1} ${2} 2>/dev/null
163 # Change e_type to ET_REL so that it can be used to link final vmlinux.
164 # Unlike GNU ld, lld does not allow an ET_EXEC input.
165 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700166}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200167
168# Create ${2} .o file with all symbols from the ${1} object file
169kallsyms()
170{
171 info KSYM ${2}
172 local kallsymopt;
173
174 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100175 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200176 fi
177
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700178 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030179 kallsymopt="${kallsymopt} --absolute-percpu"
180 fi
181
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700182 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
183 kallsymopt="${kallsymopt} --base-relative"
184 fi
185
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200186 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
187 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200188
Ard Biesheuvela0439342016-02-05 11:25:05 +0100189 local afile="`basename ${2} .o`.S"
190
191 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
192 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200193}
194
Kees Cook8959e392019-08-13 08:15:32 -0700195# Perform one step in kallsyms generation, including temporary linking of
196# vmlinux.
197kallsyms_step()
198{
199 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800200 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
201 kallsymso=${kallsyms_vmlinux}.o
Kees Cook8959e392019-08-13 08:15:32 -0700202
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700203 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Kees Cook8959e392019-08-13 08:15:32 -0700204 kallsyms ${kallsyms_vmlinux} ${kallsymso}
205}
206
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200207# Create map file with all symbols from ${1}
208# See mksymap for additional details
209mksysmap()
210{
211 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
212}
213
Shile Zhang10916702019-12-04 08:46:31 +0800214sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700215{
Shile Zhang10916702019-12-04 08:46:31 +0800216 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700217}
218
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200219# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200220cleanup()
221{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700222 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200223 rm -f .tmp_System.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200224 rm -f .tmp_vmlinux*
225 rm -f System.map
226 rm -f vmlinux
227 rm -f vmlinux.o
228}
229
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000230on_exit()
231{
232 if [ $? -ne 0 ]; then
233 cleanup
234 fi
235}
236trap on_exit EXIT
237
238on_signals()
239{
240 exit 1
241}
242trap on_signals HUP INT QUIT TERM
243
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200244# Use "make V=1" to debug this script
245case "${KBUILD_VERBOSE}" in
246*1*)
247 set -x
248 ;;
249esac
250
251if [ "$1" = "clean" ]; then
252 cleanup
253 exit 0
254fi
255
256# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900257. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200258
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200259# Update version
260info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900261if [ -r .version ]; then
262 VERSION=$(expr 0$(cat .version) + 1)
263 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200264else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900265 rm -f .version
266 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200267fi;
268
269# final build of init/
Masahiro Yamada083bc0e2020-02-11 05:06:34 +0900270${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200271
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100272#link vmlinux.o
273info LD vmlinux.o
274modpost_link vmlinux.o
Peter Zijlstra6804c1a2020-03-18 13:33:54 +0100275objtool_link vmlinux.o
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100276
277# modpost vmlinux.o to check for section mismatches
Masahiro Yamadaa7215882019-07-31 00:59:02 +0900278${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100279
Alexey Gladkov898490c2019-04-29 18:11:14 +0200280info MODINFO modules.builtin.modinfo
281${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
Masahiro Yamada8b41fc42019-12-19 17:33:29 +0900282info GEN modules.builtin
283# The second line aids cases where multiple modules share the same object.
284tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
285 tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
Alexey Gladkov898490c2019-04-29 18:11:14 +0200286
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700287btf_vmlinux_bin_o=""
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700288if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
Kees Cookaf73d782020-03-03 18:18:34 -0800289 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
290 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800291 echo >&2 "Failed to generate BTF for vmlinux"
292 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
293 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700294 fi
295fi
296
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200297kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700298kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200299kallsyms_vmlinux=""
300if [ -n "${CONFIG_KALLSYMS}" ]; then
301
302 # kallsyms support
303 # Generate section listing all symbols and add it into vmlinux
304 # It's a three step process:
305 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
306 # but __kallsyms is empty.
307 # Running kallsyms on that gives us .tmp_kallsyms1.o with
308 # the right size
309 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
310 # the right size, but due to the added section, some
311 # addresses have shifted.
312 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100313 # 3) That link may have expanded the kernel image enough that
314 # more linker branch stubs / trampolines had to be added, which
315 # introduces new names, which further expands kallsyms. Do another
316 # pass if that is the case. In theory it's possible this results
317 # in even more stubs, but unlikely.
318 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
319 # other bugs.
320 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200321 #
322 # a) Verify that the System.map from vmlinux matches the map from
323 # ${kallsymso}.
324
Kees Cook8959e392019-08-13 08:15:32 -0700325 kallsyms_step 1
326 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200327
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100328 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700329 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
330 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100331
332 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700333 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200334 fi
335fi
336
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700337vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700338
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200339# fill in BTF IDs
340if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
341info BTFIDS vmlinux
342${RESOLVE_BTFIDS} vmlinux
343fi
344
Shile Zhang10916702019-12-04 08:46:31 +0800345if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
346 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800347 if ! sorttable vmlinux; then
348 echo >&2 Failed to sort kernel tables
349 exit 1
350 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700351fi
352
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200353info SYSMAP System.map
354mksysmap vmlinux System.map
355
356# step a (see comment above)
357if [ -n "${CONFIG_KALLSYMS}" ]; then
358 mksysmap ${kallsyms_vmlinux} .tmp_System.map
359
360 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200361 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200362 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200363 exit 1
364 fi
365fi